<template>
  <el-table
    :data="jobsStore.jobs"
    :style="{
      width: '100%',
    }"
  >
    <el-table-column
      prop="filePath"
      label="File Name"
      fixed="left"
      min-width="280"
    />
    <el-table-column
      prop="convertedFilePath"
      label="Converted File"
      min-width="280"
    >
      <template #default="scope">
        {{ scope.row.convertedFilePath }}
        <el-link
          v-if="scope.row.status === 'done'"
          :icon="Download"
          :href="getDownloadLink(scope.row)"
          target="_blank"
        />
      </template>
    </el-table-column>
    <el-table-column prop="outputFormat" label="Output Format" width="180" />
    <el-table-column prop="status" label="Status" width="180">
      <template #default="scope">
        {{ scope.row.status }}
        <el-button
          v-if="scope.row.status === 'done' && !!scope.row.logs"
          text
          :icon="Memo"
          size="small"
          circle
          @click="displayedLogs = scope.row.logs"
        />
      </template>
    </el-table-column>
    <el-table-column label="Time" width="180">
      <template #default="scope">
        <span v-if="scope.row.status === 'done'">
          {{ Math.round(scope.row.convertionTime / 100) / 10 }}s
        </span>
        <span
          v-else-if="
            scope.row.status === 'pending' &&
            (scope.row.estimatedConvertionTime ?? 0 > 0)
          "
        >
          ~{{ Math.round(scope.row.estimatedConvertionTime / 100) / 10 }}s
        </span>
        <span v-else>-</span>
      </template>
    </el-table-column>
    <el-table-column
      label="Operations"
      width="280"
      align="center"
      fixed="right"
    >
      <template #default="scope">
        <ElButton
          v-if="scope.row.status === 'pending'"
          :loading="scope.row.estimatedConvertionTime !== null"
          @click="startJob(scope.row)"
          type="primary"
          >Start</ElButton
        >
        <ElButton
          v-if="scope.row.status === 'pending'"
          @click="cancelJob(scope.row)"
          >Cancel</ElButton
        >
        <ElButton
          v-if="scope.row.status !== 'pending'"
          @click="deleteJob(scope.row)"
          type="danger"
          >Delete</ElButton
        >
      </template>
    </el-table-column>
  </el-table>

  <el-dialog v-model="dialogVisible" title="Logs" width="50%">
    <!-- <span>{{ displayedLogs }}</span> -->
    <el-input
      :model-value="displayedLogs"
      :rows="15"
      type="textarea"
      resize="none"
      readonly
      placeholder="No logs"
    />
    <!-- <template #footer>
      <span class="dialog-footer">
        <el-button @click="dialogVisible = false">Cancel</el-button>
        <el-button type="primary" @click="dialogVisible = false"
          >Confirm</el-button
        >
      </span>
    </template> -->
  </el-dialog>
</template>

<script lang="ts" setup>
import { useJobsStore } from "@/stores/jobs";
import { Memo, Download } from "@element-plus/icons-vue";

const jobsStore = useJobsStore();
jobsStore.getJobs();
const displayedLogs = ref<string | undefined>();
const dialogVisible = computed({
  get: () => !!displayedLogs.value,
  set: (val: boolean) => {
    if (val === false) displayedLogs.value = undefined;
  },
});

const startJob = async (job: typeof jobsStore.jobs[number]) => {
  await jobsStore.startJob(job.id);
  setTimeout(() => {
    jobsStore.getJobs();
  }, 500);
  const estimationTime = jobsStore.jobs.find(
    (j) => j.id === job.id
  )?.estimatedConvertionTime;
  if (
    estimationTime !== null &&
    estimationTime !== undefined &&
    estimationTime > 0
  ) {
    setTimeout(() => {
      jobsStore.getJobs();
    }, estimationTime + 100);
  }
};
const cancelJob = async (job: typeof jobsStore.jobs[number]) => {
  await jobsStore.cancelJob(job.id);
  await jobsStore.getJobs();
};
const deleteJob = async (job: typeof jobsStore.jobs[number]) => {
  await jobsStore.deleteJob(job.id);
  await jobsStore.getJobs();
};

const getDownloadLink = (job: typeof jobsStore.jobs[number]) => {
  return `${import.meta.env.VITE_API_URL}/conversions/download/${job.id}`;
};
</script>
